Description

This is a guide for setting up and mining bitcoin on FreeBSD 10. This is not a comprehensive guide and is meant for educational
purposes. YMMV

Prepare the Environment

o Make sure the system is up to date:
pkg update && pkg upgrade
¢ [nstall sudo:
pkg install sudo
e Create a bitcoin user and group:

pw add group bitcoin
pw add user -n bitcoin -g bitcoin -s /sbin/nologin -c "Bitcoin"
Install Bitcoin Daemon

¢ [nstall bitcoin-daemon:
pkg install bitcoin-daemon bitcoin-utils
e Create a basic bitcoin config file:

vi /usr/local/etc/bitcoin.conf

o And set the following parameters:

rpcuser=bitcoinrpc
rpcpassword=SuperSecretPassword
rpcallowip=127.0.0.1
rpcport=2300

daemon=1

server=1

gen=0

e Create the bitcoin data directory:
mkdir /var/db/bitcoind
chown bitcoin:bitcoin /var/db/bitcoind

e Start and enable the server at boot:

echo 'bitcoind_user="bitcoin"' >> /etc/rc.conf

echo 'bitcoind_group="bitcoin"' >> /etc/rc.conf

echo 'bitcoind_data="/var/db/bitcoind"' >> /etc/rc.conf
echo 'bitcoind_enable="YES"' >> /etc/rc.conf

service bitcoind start

Useful Commands

e Get blockchain and network stats

sudo —-u bitcoin bitcoin-cli -conf=/usr/local/etc/bitcoin.
sudo —u bitcoin bitcoin-cli -conf=/usr/local/etc/bitcoin.
sudo —-u bitcoin bitcoin-cli -conf=/usr/local/etc/bitcoin.

e Create a new bitcoin address and retrieve the address:

sudo —-u bitcoin bitcoin-cli -conf=/usr/local/etc/bitcoin.
sudo —u bitcoin bitcoin-cli -conf=/usr/local/etc/bitcoin.

o Get wallet info:

sudo —u bitcoin bitcoin-cli -conf=/usr/local/etc/bitcoin.

e Get help:

sudo —u bitcoin bitcoin-cli -conf=/usr/local/etc/bitcoin.

conf
conf
conf

conf
conf

conf

conf

getblockchaininfo
getnetworkinfo
getnettotals

getnewaddress "MyBitcoin"
getaccountaddress "MyBitcoin"

getwalletinfo

help

NOTE: To ensure you DO NOT lose your wallet, make sure to keep a backup of /var/db/bitcoind/wallet.dat in a safe and secure

location.

e Get the blockchain size used on disk:

du -ch /var/db/bitcoind/blocks/

e Check the blockchain download progress:

tail -f /var/db/bitcoind/debug.log

Install Bitcoin GUI Client

e NOTE: This is an optional step used in a graphical environment.

¢ |nstall bitcoin:

pkg install bitcoin
Resources

https://en.bitcoin.it/wiki/Running_Bitcoin
https://github.com/bitcoin/bitcoin/blob/master/contrib/debian/examples/bitcoin.conf
https://bitcoin.org/en/full-node#other-linux-distributions
https://bitcoin.org/en/full-node#network-configuration
https://www.reddit.com/r/Bitcoin/comments/34amqga/freenas_full_node/

e o o o

History

#1 - 04/26/2017 11:18 PM - Daniel Curtis
- Description updated
- Status changed from New to In Progress

- % Done changed from 0 to 70

#2 - 04/27/2017 09:15 PM - Daniel Curtis
- Description updated
- Status changed from In Progress to Resolved

- % Done changed from 70 to 100

#3 - 06/04/2017 08:57 PM - Daniel Curtis

- Status changed from Resolved to Closed
